#!/usr/bin/env python3
# -*- encoding: utf-8; py-indent-offset: 4 -*-

# +------------------------------------------------------------+
# |                                                            |
# |             | |             | |            | |             |
# |          ___| |__   ___  ___| | ___ __ ___ | | __          |
# |         / __| '_ \ / _ \/ __| |/ / '_ ` _ \| |/ /          |
# |        | (__| | | |  __/ (__|   <| | | | | |   <           |
# |         \___|_| |_|\___|\___|_|\_\_| |_| |_|_|\_\          |
# |                                   custom code by SVA       |
# |                                                            |
# +------------------------------------------------------------+
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   Copyright (C) 2024  SVA System Vertrieb Alexander GmbH
#                       by leon.buhleier@sva.de

from cmk.agent_based.v2 import (
    CheckPlugin,
    AgentSection,
    CheckResult,
)

from cmk_addons.plugins.emcunity.lib.utils import *


agent_section_emcunity_pwrsupply = AgentSection(
    name="emcunity_pwrsupply",
    parse_function=parse_emcunity_generic,
)


def check_emcunity_pwrsupply(item: str, section: dict[str, dict[str, str]]) -> CheckResult:
    for _id, pwrsupply in section.items():
        if pwrsupply.get("Name") == item:
            yield from check_health(pwrsupply.get("Health state"), pwrsupply.get('Health details'))

check_plugin_emcunity_pwrsupply = CheckPlugin(
    name="emcunity_pwrsupply",
    service_name="PSU %s",
    discovery_function=discover_emcunity_generic,
    check_function=check_emcunity_pwrsupply,
)